package org.rsmod.plugins.api.model

public sealed class MessageGameType(public val id: Int) {

    public object GameMessage : MessageGameType(0)
    public object ModChat : MessageGameType(1)
    public object PublicChat : MessageGameType(2)
    public object PrivateChat : MessageGameType(3)
    public object Engine : MessageGameType(4)
    public object LoginLogoutNotification : MessageGameType(5)
    public object PrivateChatOut : MessageGameType(6)
    public object ModPrivateChat : MessageGameType(7)
    public object FriendsChat : MessageGameType(9)
    public object FriendsChatNotification : MessageGameType(11)
    public object Broadcast : MessageGameType(14)
    public object SnapshotFeedback : MessageGameType(26)
    public object ItemExamine : MessageGameType(27)
    public object NpcExamine : MessageGameType(28)
    public object ObjectExamine : MessageGameType(29)
    public object FriendNotification : MessageGameType(30)
    public object IgnoreNotification : MessageGameType(31)
    public object AutoTyper : MessageGameType(90)
    public object ModAutoTyper : MessageGameType(91)
    public object Console : MessageGameType(99)
    public object TradeReq : MessageGameType(101)
    public object Trade : MessageGameType(102)
    public object ChalReqTrade : MessageGameType(103)
    public object ChalReqFriendsChat : MessageGameType(104)
    public object Spam : MessageGameType(105)
    public object PlayerRelated : MessageGameType(106)
    public object TenSecTimeout : MessageGameType(107)
    public object Welcome : MessageGameType(108)
    public object Filtered : MessageGameType(109)
}
